﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;

namespace Sharing
{
	class Program
	{
		static void Main(string[] args)
		{
			try
			{
				deleteOldFiles();

				System.Diagnostics.Stopwatch sw = new System.Diagnostics.Stopwatch();
				sw.Start();
				int x = 0;
				//TermGraphBuilder.Enumerate(5, graph => graph.Print(); x++);
				//TermGraphBuilder.Enumerate(5, graph => graph.Print());
				Console.WriteLine(x);
				//Console.WriteLine(x / sw.ElapsedMilliseconds);

                                /*TermGraphBuilder.Enumerate(9, graph => { deleteOldFiles(); Algorithm.Start(graph); });*/
                                
                                //Algorithm.Start(TermGraphBuilder.Random(5));
                                Algorithm.Start(TermGraphBuilder.CreateTree());
			}
			catch (ExecutionException)
			{
				Console.WriteLine("non bisimili.");
			}
			catch (BuildException)
			{
				Console.WriteLine("errore nella generazione del TermGraph.");
			}
		}

		static void deleteOldFiles()
		{
			int file = 0;
			while (deleteFile(file + ".txt"))
				file++;

			file = 0;
			while (deleteFile(file + ".txt.pdf"))
				file++;
		}

		static Func<string, bool> deleteFile = (string file) =>
		{
			if (File.Exists(file))
			{
				File.Delete(file);
        return true;
			}
			return false;
		};
	}
}
